/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 *
 *******************************************************************************
 *
 * $Id: MakerNoteFormatProvider.java,v d7e8fed5e750 2009/09/17 23:55:58 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.metadata.makernote.provider;

import java.text.FieldPosition;
import java.text.Format;
import java.text.ParsePosition;
import it.tidalwave.imageio.raw.Directory;
import it.tidalwave.metadata.spi.MetadataItemFormatProvider;
import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
    
/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: MakerNoteFormatProvider.java,v d7e8fed5e750 2009/09/17 23:55:58 fabrizio $
 *
 ******************************************************************************/
public class MakerNoteFormatProvider implements MetadataItemFormatProvider<Directory>
  {
    // FIXME: merge with MetadataItemFormatImpl
    protected final static Format DEFAULT_FORMAT = new Format() 
      {
        @Override
        public StringBuffer format (@CheckForNull final Object object,
                                    @Nonnull final StringBuffer toAppendTo,
                                    final FieldPosition pos)
          {
            toAppendTo.append((object != null) ? object.toString() : "");
            return toAppendTo;
          }

        @Override
        public Object parseObject (@Nonnull final String source,
                                   @Nonnull final ParsePosition pos)
          {
            pos.setIndex(pos.getIndex() + source.length() + 1);
            return source;
          }
      };

    @Nonnull
    public Class<Directory> getItemClass()
      {
        return Directory.class;
      }

    @Nonnull
    public String getItemDisplayName() 
      {
        return "MakerNote";
      }

    @Nonnull
    public Format getFormat (final String propertyName) 
      {
        return DEFAULT_FORMAT; // FIXME
      }

    @Nonnull
    public String getDisplayName (@Nonnull final String propertyName)
      {
        return propertyName; // FIXME
      }
  }
